- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions

# MFnPointArrayData Class Reference

# OpenMaya - API module for common classes | FunctionSet classes

Search for all occurrences

## Detailed Description

Point array function set for dependency node data.

MFnPointArrayData allows the creation and manipulation of MPointArray data objects for use in the dependency graph.

If a user written dependency node either accepts or produces MPointArrays, then this class is used to extract or create the data that comes from or goes to other dependency graph nodes. The MDataHandle::type method will return kPointArray when data of this type is present. To access it, the MDataHandle::data method is used to get an MObject for the data and this should then be used to initialize an instance of MFnPointArrayData.

Examples:

  cvColorNode.cpp.

`#include <MFnPointArrayData.h>`

Inheritance diagram for MFnPointArrayData:
[legend]

List of all members.

## Public Member Functions
virtual MFn::Type | type () const
| Function set type.
virtual | ~MFnPointArrayData ()
| Destructor.
| MFnPointArrayData ()
| Default constructor.
| MFnPointArrayData (MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
unsigned int | length (MStatus *ReturnStatus=NULL) const
| Return the number of points in the instance.
MStatus | set (MPoint &element, unsigned int index)
| Set the point element at the specified index.
MStatus | copyTo (MPointArray &) const
| Copy all the points in the instance into the given MPointArray.
MStatus | set (const MPointArray &newArray)
| Set the instance to contain the points defined in the given MPointArray.
MPointArray | array (MStatus *ReturnStatus=NULL)
| Get an MPointArray containing the points stored in this instance.
MObject | create (MStatus *ReturnStatus=NULL)
| Create a new MObject, attach it to this instance, and initialize it to contain no points.
MObject | create (const MPointArray &in, MStatus *ReturnStatus=NULL)
| Create a new MObject, attach it to this instance, and initialize it to contain the data from the given MPointArray.
| MFnPointArrayData (const MObject &object, MStatus *ReturnStatus=NULL)
| Constructor.
MPoint & | operator[] (unsigned int index)
| NO SCRIPT SUPPORT.
const MPoint & | operator[] (unsigned int index) const
| NO SCRIPT SUPPORT.
## Protected Member Functions
virtual const char * | className () const
| Class name.

## Constructor & Destructor Documentation

MFnPointArrayData | ( | MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

MFnPointArrayData | ( | const MObject & | object,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Constructor.

Class constructor that initializes the function set to the given MObject.

Parameters:

  [in] | object | The MObject to attach the function set to
  [out] | ReturnStatus | the return status

Status Codes:
  - MS::kSuccess if the function set is successfully attached
  - MS::kInvalidParameter if the MObject does not represent a valid Maya object or if the function set is not allowed to attach to this MObject

## Member Function Documentation

MFn::Type type | ( |  | ) | const `[virtual]`

Search for all occurrences

Function set type.

Return the class type : MFn::kPointArrayData.

Reimplemented from MFnData.

const char * className | ( |  | ) | const `[protected, virtual]`

Search for all occurrences

Class name.

Return the class name : "MFnPointArrayData".

Reimplemented from MFnData.

unsigned int length | ( | MStatus * | ReturnStatus = `NULL` | ) | const

Search for all occurrences

Return the number of points in the instance.

Parameters:

  [out] | ReturnStatus | kFailure if the instance is not attached to an MObject, and kSuccess otherwise.

Returns:
  The number of points in the instance

MStatus set | ( | MPoint & | element,
|  | unsigned int | index
| ) |  |

Search for all occurrences

Set the point element at the specified index.

Parameters:

  [in] | element | the element to be set
  [in] | index | the index of the MPoint to set

Returns:
  - kSuccess operation successful
  - kFailure instance is not attached to an MObject

MStatus copyTo | ( | MPointArray & | dest | ) | const

Search for all occurrences

Copy all the points in the instance into the given MPointArray.

No checking is done by this class on sizes, so it is up to the user to ensure that the given MPointArray is large enough to hold the number of MPoints in the instance.

Parameters:

  [out] | dest | the MPointArray to populate

Returns:
  - kSuccess operation successful
  - kFailure instance is not attached to an MObject

MStatus set | ( | const MPointArray & | array | ) |

Search for all occurrences

Set the instance to contain the points defined in the given MPointArray.

Parameters:

  [in] | array | the MPointArray containing the data to set into this instance

Returns:
  - kSuccess operation successful
  - kFailure instance is not attached to an MObject

MPointArray array | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Get an MPointArray containing the points stored in this instance.

The MPointArray returned by this method is editable, so any changes to the return instance also affects the MObject operated upon by this function set.

Parameters:

  [out] | ReturnStatus | kFailure if the instance is not attached to an MObject, and kSuccess otherwise.

Returns:
  A copy of the MPointArray held in this instance

MObject create | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Create a new MObject, attach it to this instance, and initialize it to contain no points.

Parameters:

  [out] | ReturnStatus | kSuccess

Returns:
  The newly created MObject

Examples:
  cvColorNode.cpp.

MObject create | ( | const MPointArray & | arr,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Search for all occurrences

Create a new MObject, attach it to this instance, and initialize it to contain the data from the given MPointArray.

Parameters:

  [in] | arr | the data to use when initializing this instance
  [out] | ReturnStatus | kSuccess

Returns:
  The newly created MObject

MPoint & operator[] | ( | unsigned int | index | ) |

NO SCRIPT SUPPORT.

Extract the indicated MPoint from the instance.

The MPoint returned by this method is editable, so any changes to the return instance also affects the MObject operated upon by this function set.

No checking is done by this class to ensure that the index is valid - use the length method to determine the size of the array. If the instance is not attached to an MObject, this method will return an MPoint containing (0.0, 0.0, 0.0, 1.0).

Parameters:

  [in] | index | the index of the MPoint to extract

Returns:
  The indicated MPoint

const MPoint & operator[] | ( | unsigned int | index | ) | const

NO SCRIPT SUPPORT.

Extract the indicated MPoint from the const instance.

No checking is done by this class to ensure that the index is valid - use the length method to determine the size of the array. If the instance is not attached to an MObject, this method will return an MPoint containing (0.0, 0.0, 0.0, 1.0).

Parameters:

  [in] | index | the index of the MPoint to extract

Returns:
  The indicated MPoint

MFnPointArrayData MFnPointArrayData MFnPointArrayData MFnPointArrayData MFnPointArrayData MFnPointArrayData MFnPointArrayData MFnPointArrayData MFnPointArrayData MFnPointArrayData
MFnPointArrayData MFnPointArrayData MFnPointArrayData MFnPointArrayData MFnPointArrayData MFnPointArrayData MFnPointArrayData MFnPointArrayData MFnPointArrayData MFnPointArrayData